let print_boolean x =
	if x = true then print_string("true\n")
	else print_string("false\n")
;;

let rec print_liste_int l = match l with
	| [] 	-> print_string("\n")
	| a::b  -> print_int(a) ; print_string(" "); print_liste_int(b)
;;

let rec print_liste_tuple_3 l = match l with
	| [] -> print_string("\n")
	| (x,y,z)::b -> print_string("("); print_int(x); print_string(", "); print_int(y); print_string(", "); print_int(z); print_string(")") ;print_liste_tuple_3(b)
;;
(* Exercice 1 *)
let rec list_sigma l = match l with
	| [] 	-> 0
	| a::l' -> a + list_sigma(l')
;;

let rec mem l x = match l with 	
	| [] 	-> false
	| a::l'	-> if a = x then true else (mem l' x )
;; 

let rec map f l = match l with
	| []   -> []
	| a::b -> (f a)::(map f b)
;;

let min a b =
	if a > b then b
	else a
;;

let rec liste_min l = match l with
	| [] 		-> 0
	| a::[] 	-> a
	| a::b::c 	-> min (a)(min(b)(liste_min (c)))
;;

let rec append l1 l2 = match l1 with
	| [] -> l2
	|a::b->a::append b l2
;;

let rec rev l = match l with
	| [] 	-> []
	| a::b 	-> (rev b)@[a]
;;

let rec flatten l = match l with
	| []	-> []
	| a::l' -> a@(flatten l')
;;

let suivant l = match l with
	| [] -> []
	| a::b -> b
;;

let rec is_sorted l = match l with
	| []	-> true
	| a::b 	-> 	if b!=[] then a < (List.hd b) && is_sorted(b)
			else true
;;

let rec nb_elem l = match l with
	| [] -> 0
	| a::b -> 1 + nb_elem(b)
;;

let rec moyenne l = match l with
	| [] -> 0.0
	| a::b -> (float_of_int (list_sigma(l)) ) /. (float_of_int (nb_elem(l)))
;;

(* Exercice 2 *)
let rec enum n = 
	if n = 0 then [0]
	else (enum (n-1))@[n]
;;	

let rec enum_droite i n =
	if n = 0 then [(i,0)]
	else (enum_droite i (n-1))@[(i,n)]
;;

let rec enum_paires n i = 
	if n = 0 then enum_droite n i
	else (enum_paires (n-1)(i))@(enum_droite n i)
;;

let table_mult i j =  List.map(fun(x,y)->(x,y,x*y))(enum_paires i j);;

(* Exercice 3 *)
let rec insert l x = match l with
	| [] -> [x]
	| a::b -> 	if a > x then [x]@([a]@b)
			else if a != x then [a]@(insert b x )
			else a::b
;;

let rec sort l = match l with
	| [] 	-> []
	| a::b	-> insert (sort b) a 	
;;

let rec mem_sorted l x = match l with
	| [] 	-> false
	| a::b  -> if x = a then true else mem_sorted b x
;;

let rec union_sorted (l1, l2) = match (l1, l2) with
	| ([], [] ) 	-> 	[] 
	| (a::b, [] ) 	-> 	insert (union_sorted (b, l2) ) a
	| ([], a::b)	-> 	insert (union_sorted (l1, b) ) a
	| (a::b, c::d) 	-> 	if a = c then insert ( union_sorted (b, d) ) a 
				else if a > c then  insert ( insert ( union_sorted (b, d) ) a  ) c
				else insert ( insert ( union_sorted (b, d) ) c ) a 
;;

let rec inter_sorted (l1, l2) = match (l1, l2) with
	| ( [], [] )	-> 	[]
	| ( a::b, [])	-> 	if (mem l2 a) = true then insert ( inter_sorted (b, l2) ) a 
				else inter_sorted ( b, [])
	| ( [], a::b)	-> 	if (mem l1 a) = true then insert ( inter_sorted (b, l1) ) a
				else inter_sorted ( [], b)
	| ( a::b, c::d) -> 	if (mem l1 c)=true && true=(mem_sorted l2 a) then
					if a > c then insert ( insert ( inter_sorted (b, d) ) a ) c
					else insert ( insert ( inter_sorted (b, d) ) c ) a
			 	else if (mem_sorted l1 c) = true  && false = (mem_sorted l2 a) then
					insert ( inter_sorted (b, d) ) c
				else if (mem_sorted l2 a)=true && false=(mem_sorted l1 c) then
					insert ( inter_sorted (b, d) ) a
				else
					inter_sorted (b, d)
;;

print_liste_int ( inter_sorted ([1;2;3], [1;3;4]) ) ;;
