let rec lire_liste l = match l with
	| [] 	-> print_string("\n")
 	| a::b	-> print_int(a) ; print_string(" "); lire_liste b
;;

let max a b = 
	if a > b then a 
	else b
;;

let min a b = 
	if a > b then b
	else a
;;

let print_boolean b = 
	if b = true then print_string("true\n")
	else print_string("false\n")
;;

let rec nb_elem l =
	match l with
	| [] 	-> 0
	| a::b	-> 1 + nb_elem b
;;

(* Exercice 1 *)(* Exercice 2 *)
let rec fois n l = List.map (fun x -> x*n) l;;

let rec plus x y = match (x, y ) with
	| ([], []) 	-> []
	| (a::b, [])	-> a::plus b y
	| ([], a::b)	-> a::plus x b
	| (a::b, c::d)	-> (a+c)::plus b d
;;

let rec diff x y = match (x, y ) with
	| ([], []) 	-> []
	| (a::b, [])	-> a::diff b y
	| ([], a::b)	-> a::diff x b
	| (a::b, c::d)	-> (a-c)::diff b d
;;

let rec diff2 x y = if nb_elem x == nb_elem y then List.map2 (fun a b ->(-) a b) x y else diff x y;;
let rec plus2 x y = if nb_elem x == nb_elem y then List.map2 (fun a b ->(+) a b) x y else plus x y;;

(* Exercice 4 *)
type tree = 
	Nil
	| Node of int * tree * tree
;;

let rec taille tree = match tree with
	Nil			-> 0
	| Node(a, b, c)   	-> 1 + ( taille b ) + ( taille c )
;;

let rec fibonnacia n = 
	if n <= 1 then
		Node(n, Nil, Nil)
	else
		Node(n, fibonnacia (n-1), fibonnacia (n-2))
;;


let rec hauteur tree = match tree with
	Nil 		-> 0
	| Node(a,b,c) 	-> 1 + max ( hauteur b ) ( hauteur c ) 
;;	

let rec detect tree n = match tree with
	Nil		-> false
	| Node(a, b, c) -> if a = n then true else (detect b n )|| (detect c n)
;;

let rec complet tree = match tree with
	Nil		-> true
	| Node(a, b, c) -> 	if (hauteur b) = (hauteur c) then (complet b) = true && (complet c) = true
				else false
;;

let f = Node(2, Node(1,Nil,Nil), Node(3,Node(10,Nil,Nil),Node(4,Nil,Nil)) );;

(* Exercice 5 *)

let valeur_abr tree = match tree with
	Nil		-> 0
	| Node(a,b,c)	-> a
;;

let rec detect_abr a n = match a with
	Nil		-> false
	| Node(x,y,z) 	-> if x > n then detect_abr y n else if x < n then detect_abr z n else true
;;

let rec est_abr tree = match tree with
	Nil		-> true
	| Node(x,y,z)   -> 	if ( y != Nil ) && ( z != Nil ) then
					if ( ( valeur_abr y ) < x ) && ( ( valeur_abr z ) > x ) then
						est_abr(y) && est_abr(z)
					else
						false
				else if ( y != Nil ) && z = Nil then
					if (valeur_abr y ) < x then est_abr(y)
					else false
				else if ( y = Nil ) && z != Nil then
					if (valeur_abr z ) > x then est_abr(z)
					else false
				else true
;;
let rec ajout_abr a n = match a with
	Nil		-> Node(n, Nil, Nil)
	| Node(x, b, c) -> if ( x > n ) then (ajout_abr b n) else if ( x < n ) then ( ajout_abr c n) else a
;;

print_boolean(est_abr f);;
