#load "graphics.cma";;
#load "unix.cma";;
open Graphics;;
open Unix;;

let print_boolean b = match b with
  | false -> print_string("false\n")
  | true -> print_string("true\n")
;;

let ex1_aux () =
  ignore (Graphics.read_key()); 
  clear_graph()
;;
  
(* Exercice 1 *)
let ex1 () = 
  set_color yellow;
  fill_rect 0 0 800 500; 
  set_color black;
  ex1_aux ();  
  moveto 0 0;
  lineto 800 500;
  moveto 800 0;
  lineto 0 500;
  ex1_aux();
  draw_rect 300 150 200 200;
  ex1_aux();
;; 

(* Exercice 2 *)
let draw_line x1 y1 x2 y2 =
  moveto x1 y1;
  lineto x2 y2
;;


let ex2 n m = 
  for i = 0 to 500 do draw_line (0) (i*n) (800) (i*n) done;
  for i = 0 to 800 do draw_line (i*m) (0) (i*m) (500) done;
  n
;;

(* Exercice 3*)

let etch () = 
  let x = ref 200 in
  let y = ref 200 in
  let stop = ref false in 
  let trace = ref true in
  while !stop == false do
    if !trace == true then
      moveto !x !y;
    if !trace == true then
      lineto (!x + 1) (!y + 1);
    
    match Graphics.read_key() with
      | 'a' -> 
	print_string("Haut");
	print_newline();
	y := !y+1 
      | 'w' -> 
	print_string("Gauche");
	print_newline();
	x := !x - 1
      | 's' -> 
	print_string("Bas");
	print_newline();
	y := !y - 1
      | 'd' -> 
	print_string("Droite");
	print_newline();
	x := !x + 1
      | 'q' ->
	print_string("quitter");
	print_newline();
	stop := !stop || true
      | ' ' ->
	if !trace == true then
	  trace := !trace && false
	else 
	  trace := !trace || true
      | _ -> x := !x
  done;
  x
;;

(* Exercice 4*)
let getX g = match g with
  | (a,b) -> a
;;

let getY g = match g with
  | (a,b) -> b
;;

let print_tuple t = 
  print_int(getX t);
  print_string(", ");
  print_int(getY t);
  print_newline()
;;

(* Double Buffering *) 
let rec wait n =
  if (Unix.gettimeofday() < n) then 
    wait n
  else
    Graphics.synchronize()
;;

let ex4 () = 
  let dep = ref (1,1) in
  let pos = ref (500,0) in
  while Graphics.button_down() == false do
    clear_graph();
    pos := ((getX !pos)+(getX !dep),(getY !pos)+(getY !dep));
    fill_circle (getX !pos) (getY !pos) 50;
    wait (Unix.gettimeofday() +. 0.005);   
    if (getX !pos) <= 0 then
      dep := (1,(getY !dep));
    if (getY !pos) <= 0 then
      dep := ((getX !dep),1);
    if (getX !pos) >= 800 then
      dep := (-1, (getY !dep));
    if (getY !pos) >= 500 then
      dep := ((getX !dep), -1)
  done;
;;

(* Exercice 5 *)
type abr = 
    Nil 
  | Node of string * abr * abr
;;

let max a b = if a > b then a else b;;

let rec deep2 a = match a with
  Nil -> 0
  | Node(s, Nil,Nil) -> 0
  | Node(s, x, Nil) -> deep2 x
  | Node(s, Nil, y) -> deep2 y
  | Node(s, x, y) -> 
    1 + (deep2 x) + (deep2 y)
;;

let lien1 x y r= 
  moveto x r;
  lineto x y;
  moveto x y
;;

let flush x y s =
  set_color white;
  fill_circle (x+(String.length s)*2) (y+5) ((String.length s)*8);
  set_color black;
  moveto x y;
  draw_circle (x+(String.length s)*2) (y+5) ((String.length s)*8); 
  draw_string(s)
;;

let rec ex5 a x y = 
  moveto x y;
  match  a with
    Nil -> () 
  | Node(s,Nil,Nil) ->
    flush x y s;
  | Node(s, u, Nil) -> 
    lien1 x (y-100) y;
    ex5 u x (y-100);
    flush x y s;
  |Node(s, Nil, u)  -> 
    lien1 x (y-100) y;
    ex5 u x (y-100);
    flush x y s;
  | Node(s,u,v) -> 
    moveto x y;
    lineto (x-(1+deep2 u)*100) (max (y-(1+deep2 u)*100) (y-(1+deep2 v)*100));
    moveto x y;
    lineto (x+(1+deep2 v)*100) (max (y-(1+deep2 u)*100) (y-(1+deep2 v)*100));
    ex5 v (x+(1+deep2 v)*100) (max (y-(1+deep2 v)*100) (y-(1+deep2 v)*100));
    ex5 u (x-(1+deep2 u)*100) (max (y-(1+deep2 u)*100) (y-(1+deep2 v)*100));   
    flush x y s;
;;

(* un degradé de couleurs
let tableau_degrade_vertical = 
  let t = Array.make_matrix 500 800 (Graphics.rgb 0 0 0) in 
  for i = 0 to 500 - 1 do
    let gris = Graphics.rgb i i i in
    for j = 0 to 800 -1 do
      t.(i).(j) <- gris
    done
  done;
  t
;;
  let image_degrade_vertical = Graphics.make_image tableau_degrade_vertical;;
  Graphics.draw_image image_degrade_vertical 0 0;;
*)

open_graph " 800x800";;
(* Pour l'exercice 4 
  Graphics.auto_synchronize false;;
*)
ex5 (Node("a",
	  Node("b",
	       Node("d",
		    Nil,
		    Nil
	       ),
	       Node("e",
		    Nil,
		    Nil
	       )
	  ),
	  Node("c",
	       Node("g",
		    Node("h",
			 Nil,
			 Nil),
		    Node("i",
			 Nil, 
			 Nil)),
	       Nil)))  350 700;;
ex1_aux();;
close_graph();;

